/*--------------------------------------------------------------------
 * $Id: cloud.h,v 1.4 2001/06/20 14:30:58 pa2h Exp $
 * 
 * This file is part of libRadtran.
 * Copyright (c) 1997-2001 by Arve Kylling and Bernhard Mayer.
 * 
 * ######### Contact info: http://www.libradtran.org #########
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License   
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.        
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of  
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the   
 * GNU General Public License for more details.                    
 * 
 * You should have received a copy of the GNU General Public License          
 * along with this program; if not, write to the Free Software                
 * Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA.
 *--------------------------------------------------------------------*/

#ifndef __cloud_h
#define __cloud_h

#include <stdio.h>
#include "uvspec.h"

int setup_wcloud   (input_struct input, output_struct *output);
int setup_ice      (input_struct input, output_struct *output);
int calloc_cld_out (cld_out_struct *out, int Nlam, int Nlev);
int cp_cld_out     (cld_out_struct *target, cld_out_struct source,
		    int copy_ssproc);

int read_and_convert_wc_file (input_struct input, output_struct *output, 
			      char *filename, cld_out_struct *wc);

int read_and_convert_ic_file (input_struct input, output_struct *output, 
			      char *filename, cld_out_struct *ic);

int ssprop2optprop (cld_out_struct *cld, int iv);

int read_wcloud_prop (input_struct input, output_struct *output);
int read_icloud_prop (input_struct input, output_struct *output);

int read_cld_file (input_struct input, output_struct *output, 
		   char *filename, cld_out_struct *cld,
		   int optical);

int apply_user_defined_properties_to_cld (cld_inp_struct cldin, 
					  atm_out_struct atmout,
					  wl_out_struct  wlout,
					  cld_out_struct *cldout);


#endif



